<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px" @submit.native.prevent>
      <el-form-item label="类别" prop="typeId">
        <template>
          <el-select v-model="queryParams.typeId" filterable placeholder="请选择">
            <el-option
              v-for="item in organizationTypeList"
              :key="item.typeId"
              :label="item.typeName"
              :value="item.typeId">
            </el-option>
          </el-select>
        </template>
      </el-form-item>
      <el-form-item label="房间" prop="roomId">
        <template>
          <el-select v-model="queryParams.roomId" filterable placeholder="请选择">
            <el-option
              v-for="item in roomList"
              :key="item.roomId"
              :label="item.roomName"
              :value="item.roomId">
            </el-option>
          </el-select>
        </template>
      </el-form-item>
      <el-form-item label="大楼" prop="buildingId">
        <template>
          <el-select v-model="queryParams.buildingId" filterable placeholder="请选择">
            <el-option
              v-for="item in buildingList"
              :key="item.buildingId"
              :label="item.buildingName"
              :value="item.buildingId">
            </el-option>
          </el-select>
        </template>
      </el-form-item>
      <el-form-item label="区域" prop="areaId">
        <template>
          <el-select v-model="queryParams.areaId" filterable placeholder="请选择">
            <el-option
              v-for="item in areaList"
              :key="item.areaId"
              :label="item.areaName"
              :value="item.areaId">
            </el-option>
          </el-select>
        </template>
      </el-form-item>
      <el-form-item label="园区" prop="parkId">
        <el-select v-model="queryParams.parkId" placeholder="请选择" clearable size="small">
          <el-option
            v-for="item in parkList"
            :key="item.parkId"
            :label="item.parkName"
            :value="item.parkId"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="户型" prop="houseTypeId">
        <template>
          <el-select v-model="queryParams.houseTypeId" filterable placeholder="请选择">
            <el-option
              v-for="item in houseTypeList"
              :key="item.typeId"
              :label="item.typeName"
              :value="item.typeId">
            </el-option>
          </el-select>
        </template>
      </el-form-item>
      <el-form-item label="产业类型" prop="typeId">
        <el-select v-model="queryParams.industryType" placeholder="请选择类型" clearable size="small">
          <el-option
            v-for="dict in dict.type.industry_type"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="名称" prop="organizationName">
        <el-input
          v-model="queryParams.organizationName"
          placeholder="请输入名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="楼层" prop="floor">
        <el-input
          v-model="queryParams.floor"
          placeholder="请输入楼层"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="是否重要" prop="important">
        <el-select v-model="queryParams.important" placeholder="请选择是否重要" clearable size="small">
          <el-option
            v-for="dict in dict.type.sys_yes_no"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['info:organizationInfo:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['info:organizationInfo:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['info:organizationInfo:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['info:organizationInfo:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="organizationInfoList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="主体id" align="center" prop="organizationId" />
      <el-table-column label="类型" align="center">
        <template slot-scope="scope">
          {{ getOrganizationTypeName(scope.row.typeId) }}
        </template>
      </el-table-column>
      <el-table-column label="房间" align="center">
        <template slot-scope="scope">
          {{ getRoomName(scope.row.roomId) }}
        </template>
      </el-table-column>
      <el-table-column label="大楼" align="center">
        <template slot-scope="scope">
          {{ getBuildingName(scope.row.buildingId) }}
        </template>
      </el-table-column>
      <el-table-column label="区域" align="center">
        <template slot-scope="scope">
          {{ getAreaName(scope.row.areaId) }}
        </template>
      </el-table-column>
      <el-table-column label="产业类型" align="center">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.industry_type" :value="scope.row.industryType"/>
        </template>
      </el-table-column>
      <el-table-column label="名称" align="center" prop="organizationName" />
      <el-table-column label="是否重要" align="center" prop="important">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.sys_yes_no" :value="scope.row.important"/>
        </template>
      </el-table-column>
      <el-table-column label="logo" align="center" prop="logo">
        <template slot-scope="scope">
            <img :src="BASE_URL + scope.row.logo" style="width: 50px; height: 50px;">
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="140">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['info:organizationInfo:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['info:organizationInfo:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改主体信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="类别" prop="typeId">
          <template>
            <el-select v-model="form.typeId" filterable placeholder="请选择">
              <el-option
                v-for="item in organizationTypeList"
                :key="item.typeId"
                :label="item.typeName"
                :value="item.typeId">
              </el-option>
            </el-select>
          </template>
        </el-form-item>
        <el-form-item label="房间" prop="roomId">
          <template>
            <el-select v-model="form.roomId" filterable placeholder="请选择">
              <el-option
                v-for="item in roomList"
                :key="item.roomId"
                :label="item.roomName"
                :value="item.roomId">
              </el-option>
            </el-select>
          </template>
        </el-form-item>
        <el-form-item label="大楼" prop="buildingId">
          <template>
            <el-select v-model="form.buildingId" filterable placeholder="请选择">
              <el-option
                v-for="item in buildingList"
                :key="item.buildingId"
                :label="item.buildingName"
                :value="item.buildingId">
              </el-option>
            </el-select>
          </template>
        </el-form-item>
        <el-form-item label="区域" prop="areaId">
          <template>
            <el-select v-model="form.areaId" filterable placeholder="请选择">
              <el-option
                v-for="item in areaList"
                :key="item.areaId"
                :label="item.areaName"
                :value="item.areaId">
              </el-option>
            </el-select>
          </template>
        </el-form-item>
        <el-form-item label="园区" prop="parkId">
          <el-select v-model="form.parkId" placeholder="请选择" clearable size="small">
            <el-option
              v-for="item in parkList"
              :key="item.parkId"
              :label="item.parkName"
              :value="item.parkId"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="户型" prop="houseTypeId">
          <template>
            <el-select v-model="form.houseTypeId" filterable placeholder="请选择">
              <el-option
                v-for="item in houseTypeList"
                :key="item.typeId"
                :label="item.typeName"
                :value="item.typeId">
              </el-option>
            </el-select>
          </template>
        </el-form-item>
        <el-form-item label="产业类型" prop="typeId">
          <el-select v-model="form.industryType" placeholder="请选择类型" clearable size="small">
            <el-option
              v-for="dict in dict.type.industry_type"
              :key="dict.value"
              :label="dict.label"
              :value="parseInt(dict.value)"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="名称" prop="organizationName">
          <el-input v-model="form.organizationName" placeholder="请输入名称" />
        </el-form-item>
        <el-form-item label="楼层" prop="floor">
          <el-input v-model="form.floor" placeholder="请输入楼层" />
        </el-form-item>
        <el-form-item label="简介" prop="intro">
          <el-input v-model="form.intro" placeholder="请输入简介" />
        </el-form-item>
        <el-form-item label="二维坐标" prop="lngLat">
          <el-input v-model="form.lngLat" placeholder="请输入二维坐标" />
        </el-form-item>
        <el-form-item label="三维坐标" prop="rasterLngLat">
          <el-input v-model="form.rasterLngLat" @focus="openditu">
            {{ form.rasterLngLat}}
          </el-input>
        </el-form-item>
        <el-form-item label="是否重要">
          <el-switch v-model="form.important"></el-switch>
        </el-form-item>
        <el-form-item label="地址" prop="address">
          <el-input v-model="form.address" placeholder="请输入地址" />
        </el-form-item>
        <el-form-item label="logo">
          <imageUpload v-model="form.logo"/>
        </el-form-item>
        <el-form-item label="联系方式" prop="telephone">
          <el-input v-model="form.telephone" placeholder="请输入联系方式" />
        </el-form-item>
        <el-form-item label="主要产品" prop="product">
          <el-input v-model="form.product" placeholder="请输入主要产品" />
        </el-form-item>
        <el-form-item label="入驻时间" prop="enterTime">
          <el-date-picker clearable size="small"
                          v-model="form.enterTime"
                          type="datetime"
                          value-format="yyyy-MM-dd HH:mm:ss"
                          placeholder="选择入驻时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="员工人数" prop="employeNum">
          <el-input-number v-model="form.employeNum" controls-position="right"   :min="0" placeholder="请输入员工人数" />
        </el-form-item>
         <el-form-item label="宣传视频">
          <fileUpload v-model="form.audio"/>
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <el-dialog title="地图" :visible.sync="dialogVisible" width="80%">
      <div id='mainMap'>
        <div id="mapDiv" style="width:100%; height:700px">
        </div>
      </div>
      <input type="button" value="清除" @click='clearmian()' />
      <input type="button" value="标点工具" @click='openMarkTool()' />
      <span slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">取 消</el-button>
        <el-button type="primary" @click='tijiao'>确定</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
import { listOrganizationInfo, getOrganizationInfo, delOrganizationInfo, addOrganizationInfo, updateOrganizationInfo, exportOrganizationInfo } from "@/api/info/organizationInfo";
import { listBuildingInfo, getBuildingInfo } from "@/api/info/buildingInfo";
import { listAreaInfo, getAreaInfo } from "@/api/info/areaInfo";
import { listRoomInfo, getRoomInfo } from "@/api/info/roomInfo";
import { listOrganizationType, getOrganizationType } from "@/api/type/organizationType";
import { listHouseType, getHouseType } from "@/api/type/houseType";
import { listParkInfo, getParkInfo, delParkInfo, addParkInfo, updateParkInfo, exportParkInfo } from "@/api/info/parkInfo";

export default {
  name: "OrganizationInfo",
  dicts: ['sys_yes_no', 'industry_type'],
  data() {
    return {
      parkList: [],
      dialogVisible: false,
      map: null,
      handler: null,
      markPoints: '', // 保存标记点的坐标
      houseTypeList: [],
      organizationTypeList: [],
      areaList: [],
      roomList: [],
      buildingList: [],
      BASE_URL: BASE_URL,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 主体信息表格数据
      organizationInfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        typeId: null,
        roomId: null,
        buildingId: null,
        areaId: null,
        organizationName: null,
        important: null,
        industryType: null,
        houseTypeId: null,
        parkId: null,
      },
      queryBuildingParams: {
        pageNum: 1,
        pageSize: 999999,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        organizationId: [
          { required: true, message: "主体id不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
    this.getBuilding();
    this.getRoomList();
    this.getAreaList();
    this.getOrganizationTypeList();
    this.getHouseTypeLst();
    this.getParkList();
  },
  methods: {

    getParkList() {
      listParkInfo(this.queryBuildingParams).then(response => {
        this.parkList = response.data.list;
      });
    },


    // 销毁天地图
    destructionTMap ()  {
      if (this.map) {
        this.map = null;
        // 直接将节点给删掉
        console.log('1qsad');

        const parentEl = document.getElementById('mainMap');
        const cahildrenEl1 = document.getElementById('mapDiv');
        if(cahildrenEl1) parentEl.removeChild(cahildrenEl1);
        // 然后再手动将节点加进来
        const newCahildrenEl = document.createElement("div");
        newCahildrenEl.id = 'mapDiv'
        newCahildrenEl.style = 'height: 700px;width: 100%;'
        parentEl.appendChild(newCahildrenEl)
      }
    },

    tijiao() {
      console.log('多边形数据:', this.form.rasterLngLat);
      console.log('多边形数据:', this.markPoints);
      this.form.rasterLngLat = this.markPoints
      this.destructionTMap()
      this.dialogVisible = false;
    },

    clearmian() {
      if (this.handler) this.handler.close();
      this.map.clearOverLays(); // 清除所有覆盖物
      this.markPoints = ''; // 清除保存的标记点坐标
    },

    openMarkTool() {
      console.log("1111111111")
      if (this.handler) this.handler.close(); // 关闭之前的工具

      this.handler = new T.MarkTool(this.map); // 创建标点工具
      this.handler.open(); // 打开标点工具

      this.handler.on("mouseup", (e) => {
        let drawData1 = e.currentLnglat.lat+","+e.currentLnglat.lng
        this.markPoints = drawData1;
      });

      this.handler.on("close", () => {
        // 标点工具关闭时的处理
        this.handler = null;
      });
    },


    openditu() {
      console.log('打开地图对话框');
      this.dialogVisible = true;
      this.$nextTick(() => {
        const T = window.T;
        const zoom = 12;
        this.map = new T.Map('mapDiv');
        this.map.centerAndZoom(new T.LngLat(103.96, 30.66), zoom);
        // 创建标注工具对象
        this.handler = new T.MarkTool(this.map);
        console.log('handler 初始化完成:', this.handler);
        console.log('kanknak1', this.form.rasterLngLat);
        let points = new T.LngLat();
        if (this.form.rasterLngLat) {
          const coordinates = this.form.rasterLngLat.split(',');
          points =  new T.LngLat(coordinates[1], coordinates[0]);
        }
        // 创建面对象
        console.log('kanknak2', points);
        const marker = new T.Marker(points);
        // 向地图上添加面
        this.map.addOverLay(marker);
      });
    },
    getHouseTypeName(typeId) {
      const houseType = this.houseTypeList.find(b => b.typeId === typeId);
      return houseType ? houseType.typeName : '未知';
    },

    getHouseTypeLst() {
      listHouseType(this.queryBuildingParams).then(response => {
        this.houseTypeList = response.data.list;
      });
    },

    getOrganizationTypeName(typeId) {
      const type = this.organizationTypeList.find(b => b.typeId === typeId);
      return type ? type.typeName : '未知';
    },

    getAreaName(areaId) {
      const area = this.areaList.find(b => b.areaId === areaId);
      return area ? area.areaName : '未知';
    },

    getRoomName(roomId) {
      const room = this.roomList.find(b => b.roomId === roomId);
      return room ? room.roomName : '未知';
    },

    getBuildingName(buildingId) {
      const building = this.buildingList.find(b => b.buildingId === buildingId);
      return building ? building.buildingName : '未知';
    },

    getOrganizationTypeList() {
      listOrganizationType(this.queryBuildingParams).then(response => {
        this.organizationTypeList = response.data.list;
      });
    },

    getAreaList() {
      listAreaInfo(this.queryBuildingParams).then(response => {
        this.areaList = response.data.list;
      });
    },

    getRoomList() {
      listRoomInfo(this.queryBuildingParams).then(response => {
        this.roomList = response.data.list;
      });
    },

    getBuilding() {
      listBuildingInfo(this.queryBuildingParams).then(response => {
        this.buildingList = response.data.list;
      });
    },
    /** 查询主体信息列表 */
    getList() {
      this.loading = true;
      listOrganizationInfo(this.queryParams).then(response => {
        this.organizationInfoList = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        organizationId: null,
        typeId: null,
        roomId: null,
        buildingId: null,
        areaId: null,
        organizationName: null,
        intro: null,
        lngLat: null,
        rasterLngLat: null,
        important: true,
        typeName: null,
        address: null,
        logo: null,
        telephone: null,
        product: null,
        enterTime: null,
        employeNum: null,
        audio: null,
        industryType: null,
        houseTypeId: null,
        floor: null,
        parkId: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.queryParams.industryType = null
      console.log(this.queryParams)
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.organizationId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加主体信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const organizationId = row.organizationId || this.ids
      getOrganizationInfo(organizationId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改主体信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.organizationId != null) {
            updateOrganizationInfo(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addOrganizationInfo(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const organizationIds = row.organizationId || this.ids;
      this.$modal.confirm('是否确认删除主体信息编号为"' + organizationIds + '"的数据项？').then(function() {
        return delOrganizationInfo(organizationIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$modal.confirm('是否确认导出所有主体信息数据项？').then(() => {
        this.exportLoading = true;
        return exportOrganizationInfo(queryParams);
      }).then(response => {
        this.$download.name(response.msg);
        this.exportLoading = false;
      }).catch(() => {});
    }
  }
};
</script>
